/* These include files are needed for the following template code.            */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>


#include <uf.h>
#include <uf_defs.h>
#include <uf_styler.h>
#include <uf_mb.h>
#include <uf_ui.h>
#include <uf_ui_types.h>
#include <uf_exit.h>
#include <uf_disp.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_vec.h>
#include <uf_mtx.h>
#include <uf_csys.h>
#include <uf_attr.h>
#include "styler_Color_Process_Add_Code.h"

char *poln_ad_code_tbl[] = {	"A -  ",
								"B -  "
							};//2

int		ad_code_cnt =2;

struct add{
	char add_code[UF_ATTR_MAX_STRING_LEN+1];
	char *sim;
}all_add[2]={
			  {
				"A -  ",
				 "A"							
			  },
			  {
			     "B -  ",
			     "B"							
			  }
			};

int		pr_code_cnt =26;

char *poln_pr_code_tbl[] =
					{	"A -  ",
						"B -  ",
						"C -  ",
						"D -     ",
						"E -     ",
						"F -  ",
						"G -    ",
						"H -    ",
						"I -  ",
						"J -  -    ",
						"K -  -    ",
						"L -  -    ",
						"M -  -    ",
						"N -  ",
						"O -      D",
						"P -      E",
						"Q -      G",
						"R -      H",
						"S -      J",
						"T -      K",
						"U -      L",
						"V -      M",
						"W -  ",
						"X -     ",
						"Y -  ",
						"Z -  "
					};//26

struct process{
	char process_code[UF_ATTR_MAX_STRING_LEN+1];
	char *sim;
}all_process[26]={
					{
					  "A -  ",
					  "A"							
					},
					{
					  "B -  ",
					  "B"							
					},
					{
					  "C -  ",
					  "C"							
					},
					{
					  "D -     ",
					  "D"							
					},
					{
					  "E -     ",
					  "E"							
					},
					{
					  "F -  ",
					  "F"							
					},
					{
					  "G -    ",
					  "G"							
					},
					{
					  "H -    ",
					  "H"							
					},
					{
					  "I -  ",
					  "I"							
					},
					{
					  "J -  -    ",
					  "J"							
					},
					{
					  "K -  -    ",
					  "K"							
					},
					{
					  "L -  -    ",
					  "L"							
					},
					{
					  "M -  -    ",
					  "M"							
					},
					{
					  "N -  ",
					  "N"							
					},
					{
					  "O -      D",
					  "O"							
					},
					{
					  "P -      E",
					  "P"							
					},
					{
					  "Q -      G",
					  "Q"							
					},
					{
					  "R -      H",
					  "R"							
					},
					{
					  "S -      J",
					  "S"							
					},
					{
					  "T -      K",
					  "T"							
					},
					{
					  "U -      L",
					  "U"							
					},
					{
					  "V -      M",
					  "V"							
					},
					{
					  "W -  ",
					  "W"							
					},
					{
					  "X -     ",
					  "X"							
					},
					{
					  "Y -  ",
					  "Y"							
					},
					{
					  "Z -  ",
					  "Z"							
					}
				 };//26

extern	int			flag_err;
extern				FILE*	prterr;
extern	int			errorCode;

extern  int			cod_Color;				
extern	int			ind_pr_code;
extern	int			ind_ad_code;


// 
extern	char	*atr_pr_code;
extern	char	*atr_ad_code;

extern	int		choise_DIALOG;		//. - OK -1;  Cancel - 0;
extern	int		POVTOR;				//. -  OK ==1;  Cancel ==0;

extern	char	*file_dlg;


#define IPACCOLOR_CB_COUNT ( 7 + 1 ) /* Add 1 for the terminator */

#define	PRTERR(line)if(errorCode)\
	{PrintErrorMessage(errorCode,line);errorCode=0; flag_err=1; goto term;}

//********************************************************************
static void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d	message=%s		line=%d	\n",
			errorCode,message,line);
	}
}
//******************************************************************** 

static UF_STYLER_callback_info_t IPACCOLOR_cbs[IPACCOLOR_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, IPACCOLOR_konstr_dialog},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, IPACCOLOR_OK_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB        , 0, IPACCOLOR_apply_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CANCEL_CB       , 0, IPACCOLOR_Cancel_cb},
 {IPACCOLOR_COLOR_NUM   , UF_STYLER_ACTIVATE_CB     , 0, IPACCOLOR_obr_color},
 {IPACCOLOR_PROCESS_CODE, UF_STYLER_ACTIVATE_CB     , 0, IPACCOLOR_obr_process_code},
 {IPACCOLOR_ADD_CODE    , UF_STYLER_ACTIVATE_CB     , 0, IPACCOLOR_obr_add_code},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};

static UF_MB_styler_actions_t actions[] = {
    { "styler_Color_Process_Add_Code",  NULL,   IPACCOLOR_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};


//*****************************************************************************************
extern int DIALOG_Color_Process_Add_Code ( int *response )
{
    int  error_code = 0;
 
    if ( ( error_code = UF_initialize() ) != 0 ) 
           return (0) ;

    if ( ( error_code = UF_STYLER_create_dialog ( "D:\\application\\styler_Color_Process_Add_Code.dlg",
           IPACCOLOR_cbs,      /* Callbacks from dialog */
           IPACCOLOR_CB_COUNT, /* number of callbacks*/
           NULL,        /* This is your client data */
           response ) ) != 0 )
    {
          char fail_message[133];

          /* Get the user function fail message based on the fail code.*/
          UF_get_fail_message(error_code, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message ); 
    }


    UF_terminate();                             
    return (error_code);
}

//*****************************************************************************************
extern void ufusr_cleanup (void)
{
    return;
}

//*****************************************************************************************
int IPACCOLOR_konstr_dialog ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{   /*  .
	      , 
	    :
	
	 											 			

	IPACCOLOR_PROCESS_CODE        "PROCESS_CODE"		Process code
	IPACCOLOR_ADD_CODE            "ADD_CODE"			Additional Info Code
	
	      -> flag_err=1 ->  
         "  .  ." 
	 ,   .     .
 */

UF_STYLER_item_value_type_t	value;

flag_err=0;


     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );


	 //   Color
	 value.item_attr = UF_STYLER_VALUE;
	 value.item_id = "COLOR_NUM";
	 if(POVTOR==1)
		 value.value.integer = cod_Color;
		 else value.value.integer = 1;		
	 errorCode=UF_STYLER_set_value(dialog_id, &value); PRTERR(__LINE__);

     //   Process code
	 value.item_attr = UF_STYLER_SUBITEM_VALUES;
	 value.item_id = "PROCESS_CODE";
	 value.count = pr_code_cnt;
	 value.value.strings = poln_pr_code_tbl;
	 errorCode=UF_STYLER_set_value(dialog_id, &value); PRTERR(__LINE__);

 	 value.item_attr = UF_STYLER_VALUE;
	 value.item_id = "PROCESS_CODE";
	 if(POVTOR==1)
		 value.subitem_index = ind_pr_code;
		 else value.subitem_index = 7;		//  
	 errorCode=UF_STYLER_set_value(dialog_id, &value); PRTERR(__LINE__);
   

     //    Additional Info Code
	 value.item_attr = UF_STYLER_SUBITEM_VALUES;
	 value.item_id = "ADD_CODE";
	 value.count = ad_code_cnt;
	 value.value.strings = poln_ad_code_tbl;
	 errorCode=UF_STYLER_set_value(dialog_id, &value); PRTERR(__LINE__);

 	 value.item_attr = UF_STYLER_VALUE;
	 value.item_id = "ADD_CODE";
	 if(POVTOR==1)
		value.subitem_index = ind_ad_code;
		else value.subitem_index = 0;
	 errorCode=UF_STYLER_set_value(dialog_id, &value); PRTERR(__LINE__);


   

	//fprintf(prterr,"\nIPACCOLOR_konstr_dialog - \n");
	UF_terminate ();
	return (UF_UI_CB_CONTINUE_DIALOG); 


	 
term:
	//fprintf(prterr,"\nIIPACCOLOR_konstr_dialog -   .  .\n");
	//fprintf(prterr,"\nIPACCOLOR_konstr_dialog - flag_err=%d\n", flag_err);
	uc1601("  .  .", 1);
	UF_terminate ();
    return (UF_UI_CB_CONTINUE_DIALOG); 

}//IPACCOLOR_konstr_dialog

//*****************************************************************************************
int IPACCOLOR_OK_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/*  "".
	
	 . "Process Code" -> PROCESS_CODE.    atr_pr_code.

	 . "Additional Info Code" -> ADD_CODE.    atr_ad_code.
	 
	         -> 
	flag_err=1 ->      :
	"   OK.  ."  ,   . 
	  .

         flag_err.      1
	      APPLAY,     
	 " "	 . 
	   "  flag_err=1"   .
		

	     -> choise_DIALOG=1 -  ( )
 */
	UF_STYLER_item_value_type_t	value;
	
    if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     ///fprintf(prterr,"\nIPACCOLOR_OK_cb ->   flag_err=%d\n", flag_err);
	if(flag_err ==1) 
	{
		fprintf(prterr,"IPACCOLOR_OK_cb ->   flag_err=1.\n");
		uc1601("  flag_err=1.", 1);
		UF_terminate ();
		return ( UF_UI_CB_EXIT_DIALOG ); 
	}

	 //*******  . "Color" -> COLOR_NUM *******
	 value.item_attr=UF_STYLER_VALUE;
	 value.item_id="COLOR_NUM";
	 errorCode=UF_STYLER_ask_value(dialog_id, &value);		PRTERR(__LINE__);
	 cod_Color=value.value.integer;					
	 fprintf(prterr,"\nIPACCOLOR_OK_cb ->   cod_Color=%d\n",cod_Color);

	 
	 //*******  . "Process Code" -> PROCESS_CODE *******
	 value.item_attr=UF_STYLER_VALUE;
	 value.item_id="PROCESS_CODE";
	 errorCode=UF_STYLER_ask_value(dialog_id, &value);		PRTERR(__LINE__);
	 ind_pr_code=value.value.integer;					// = .
	 //fprintf(prterr,"\nIPACCOLOR_OK_cb ->   ind_pr_code=%d\n",ind_pr_code);

	 //(  - PROCESS_CODE).   .
	 value.item_attr=UF_STYLER_SUBITEM_VALUES;
	 value.item_id="PROCESS_CODE";
	 errorCode=UF_STYLER_ask_value(dialog_id, &value);		PRTERR(__LINE__);
	 atr_pr_code = all_process[ind_pr_code].sim;
	 //fprintf(prterr,"IPACCOLOR_OK_cb -> atr_pr_code=%s\n",atr_pr_code);





	 /*******  . "Additional Info Code" -> ADD_CODE *******/
	 value.item_attr=UF_STYLER_VALUE;
	 value.item_id="ADD_CODE";
	 errorCode=UF_STYLER_ask_value(dialog_id, &value);		PRTERR(__LINE__);
	 ind_ad_code=value.value.integer;					// = .
	 //fprintf(prterr,"\nIPACCOLOR_OK_cb ->  ind_ad_code=%d\n",ind_ad_code);

	 //(  - Additional Info Code).   .
	 value.item_attr=UF_STYLER_SUBITEM_VALUES;
	 callback_data->item_id="ADD_CODE";
	 errorCode=UF_STYLER_ask_value(dialog_id, &value);		PRTERR(__LINE__);
	 atr_ad_code = all_add[ind_ad_code].sim;
	 //fprintf(prterr,"IPACCOLOR_OK_cb -> atr_ad_code=%s\n",atr_ad_code);


     choise_DIALOG=1;	//   -  
	POVTOR=1;
	
	

//fprintf(prterr,"\nIPACCOLOR_OK_cb ");
UF_terminate ();
return (UF_UI_CB_EXIT_DIALOG);

term:
		fprintf(prterr,"IPACCOLOR_OK_cb ->    OK.  .\n");
		uc1601("   OK.  .", 1);
		UF_terminate ();
		return (UF_UI_CB_EXIT_DIALOG);
                        

}//IPACCOLOR_OK_cb

//*****************************************************************************************
int IPACCOLOR_apply_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/*  "Applay".
	:		
				Process code
				Additional Info Code
				
					 
	    .

	         -> 
	flag_err=1 ->      :
	"  .  ." 
	 ,   .

	     flag_err.      1
	  ,      " "	
	 .    "  flag_err=1"  
	.
 */    
   
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     //fprintf(prterr,"\nIPACCOLOR_apply_cb ->   flag_err=%d\n", flag_err);
	if(flag_err ==1) 
	{
		fprintf(prterr,"IPACCOLOR_apply_cb->   flag_err=1\n");
		uc1601("  flag_err=1.", 1);
		UF_terminate ();
		return ( UF_UI_CB_EXIT_DIALOG ); 
	}
	      
	 
     //    Process code
	 callback_data->item_attr = UF_STYLER_SENSITIVITY;
	 callback_data->item_id = "PROCESS_CODE";
	 callback_data->subitem_index = UF_STYLER_NO_SUB_INDEX;
	 callback_data->value.integer = TRUE;
	 errorCode=UF_STYLER_set_value(dialog_id, callback_data); PRTERR(__LINE__);

     //    Additional Info Code
	 callback_data->item_attr = UF_STYLER_SENSITIVITY;
	 callback_data->item_id = "ADD_CODE";
	 callback_data->subitem_index = UF_STYLER_NO_SUB_INDEX;
	 callback_data->value.integer = TRUE;
	 errorCode=UF_STYLER_set_value(dialog_id, callback_data); PRTERR(__LINE__);

 UF_terminate ();

    //fprintf(prterr,"\nIPACCOLOR_apply_cb  - ");
    return (UF_UI_CB_CONTINUE_DIALOG); 

term:
     
	fprintf(prterr,"IPACCOLOR_apply_cb ->    applay.  .\n");
	uc1601("   applay.  .", 1);
	UF_terminate ();
	return (UF_UI_CB_EXIT_DIALOG);


}//IPACCOLOR_apply_cb


//*****************************************************************************************
int IPACCOLOR_Cancel_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/*
	  "Cancel".
	 choise_DIALOG=0 - . .  -  
 */

     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

    
		choise_DIALOG=0;
		POVTOR=0;

     UF_terminate ();

   
	//fprintf(prterr,"\nIPACCOLOR_Cancel_cb   - ");
    return ( UF_UI_CB_EXIT_DIALOG );                       

}//IPACCOLOR_Cancel_cb 

//*****************************************************************************************
int IPACCOLOR_obr_color ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/*
   "Process code"  ("COLOR_NUM").
    [1 - 216] -   .
 extern  int			cod_Color;		
 */
     
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

     // ,      -    
	 callback_data->item_attr=UF_STYLER_SENSITIVITY;
	 callback_data->item_id = "COLOR_NUM";	
	 callback_data->value.integer = FALSE;	
	 errorCode=UF_STYLER_set_value(dialog_id, callback_data); PRTERR(__LINE__);
       
 term:
	UF_terminate ();
   	//fprintf(prterr,"\nIPACCOLOR_obr_process_code  - ");
    return (UF_UI_CB_CONTINUE_DIALOG); 
    
}//IPACCOLOR_obr_color 

//*****************************************************************************************
int IPACCOLOR_obr_process_code ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/*
   "Color"  ("PROCESS_CODE").
      -   .

 */
	
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

   	 
	 // ,      -    
	 callback_data->item_attr=UF_STYLER_SENSITIVITY;
	 callback_data->item_id = "PROCESS_CODE";	
	 callback_data->value.integer = FALSE;	
	 errorCode=UF_STYLER_set_value(dialog_id, callback_data); PRTERR(__LINE__);
    

term:
	UF_terminate ();
   	//fprintf(prterr,"\nIPACCOLOR_obr_process_code  - ");
    return (UF_UI_CB_CONTINUE_DIALOG); 
    
}//IPACCOLOR_obr_process_code


//*****************************************************************************************
int IPACCOLOR_obr_add_code ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/*
   "Additional Info Code"  ("ADD_CODE").
      -   .

 */

  
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

   	
	 // ,      -    
	 callback_data->item_attr=UF_STYLER_SENSITIVITY;
	 callback_data->item_id = "ADD_CODE";	
	 callback_data->value.integer = FALSE;	
	 errorCode=UF_STYLER_set_value(dialog_id, callback_data); PRTERR(__LINE__);

term:
    UF_terminate ();
	//fprintf(prterr,"\nIPACCOLOR_obr_add_code   - ");
    return (UF_UI_CB_CONTINUE_DIALOG); 
   
}//IPACCOLOR_obr_add_code 



