/**********************************************************************

** set_attr_from_color.cpp

1  2007  

???????????????????????????????????
   -  (..  "RIVET"  .
    ,   .

   -,   
.      <UF_UI_select_with_class_dialog>
      <component_init_proc>
    <rivet_attr>  
    <rivet>.

*********************************************************/
/* Include files */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include <uf.h>
#include <uf_ui.h>
#include <uf_ui_types.h>
#include <uf_exit.h>
#include <uf_disp.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_vec.h>
#include <uf_mtx.h>
#include <uf_csys.h>
#include <uf_attr.h>




#define FREE_OBJ(object)\
	if(object)\
		for(i=0;i<count;i++)\
		{\
			errorCode=UF_DISP_set_highlight(object[i],0);\
			PRTERR(__LINE__);\
		}\
	UF_free(object);

extern	FILE*		prterr;
extern	int			errorCode;

extern  int			cod_Color;		

extern	char	*atr_rivet;			    
extern	char	*atr_pr_code;			
extern	char	*atr_ad_code;			
extern	char	*atr_fast_code;			
extern	char	*atr_grip_lng;			

extern	int			sel_comp;
extern  tag_t	    disp_part;

int	component_init_proc(UF_UI_selection_p_t select, void* user_data);

#define PRTERR(line)if(errorCode)\
			{PrintErrorMessage(errorCode,line);errorCode=0;goto term;}

//******************************************************************
static	void	PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d		message=%s		line=%d\n",
			errorCode,message,line);
		fflush(prterr);
	}
}
//******************************************************************
static int rivet_attr(	tag_t object,
						int type[3],
						void *user_data,
						UF_UI_selection_p_t select)
{//     "rivet"

	int					indx,
						attr_type=UF_ATTR_string;
	
	char				title[100];

	UF_ATTR_value_t		value;

	static char			rivet_type[300];

	value.value.string=rivet_type;

	indx=0;
	errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
	PRTERR(__LINE__);	

	while(indx)
	{
		if(strcmp(title,"RIVET")==0)
			return UF_UI_SEL_ACCEPT;
		errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
		PRTERR(__LINE__);
	}


term:
	return UF_UI_SEL_REJECT;

}
//******************************************************************
int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	
		sel_code,
		ret_code,
		num_triples=1;
	UF_UI_mask_t	
		mask_triples[]={UF_component_type,0,0};

	
	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);
	PRTERR(__LINE__);


	sel_code= UF_UI_set_sel_procs(select,rivet_attr,NULL,user_data);
	PRTERR(__LINE__);

	if( (ret_code==0) && (sel_code==0) )
		return UF_UI_SEL_SUCCESS;


term:

	return UF_UI_SEL_FAILURE;
}


//******************************************************************
int	set_attr_from_color(void)
{/*	 		????????????????????????????????
	 ,     "RIVET".
	   !!!!!!!!!.

	   (  ) :	pr_code, 
																		ad_code, 
																		
	   ,   . 
	


	e scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY,     
	..       

        ,     
	"set_attr_to_component - ",  0, 
	
	      -  2.

	
 */
	tag_t	child_tag, ttt;
	int		child_count=0;		//-   
	int		i;
	tag_t	child_array[30000];


	// -    
	child_tag=NULL_TAG;
	do
	{
		child_tag=UF_ASSEM_cycle_inst_of_part(disp_part, child_tag);
				
		if(child_tag==NULL_TAG)
		{
			uc1601("child_tag=NULL_TAG",1);
			fprintf(prterr,"\nset_attr_from_color ->child_tag==NULL_TAG");
		}
		else
			{   
				child_array[child_count]=child_tag;	  
				child_count=child_count+1;
			}

	}while(child_tag!=NULL_TAG);

	fprintf(prterr,"\n\nset_attr_from_color ->	child_count = %d",child_count);

	
	{//   ,   RIVET=WORK
		
		int		type=UF_ATTR_string;
		char*	title="RIVET";
		int		title_type;
		int		rivet_flag, sum, i;
		
		tag_t	part_occ_tag;

		UF_ATTR_value_t	value;

		for(i=0, sum=0; i<child_count; i++)
			{
			//    ,    part_occ 
			part_occ_tag=UF_ASSEM_ask_part_occ_of_inst(NULL, child_array[i] );
			//errorCode=UF_DISP_set_highlight (part_occ_tag, 1);	//

				//   RIVET
				errorCode=UF_ATTR_find_attribute(part_occ_tag,type,title,&title_type);PRTERR(__LINE__);
				


				// errorCode=UF_ATTR_find_attribute(child_array[i],type,title,&title_type);PRTERR(__LINE__);
				if(title_type==UF_ATTR_string)
				{
					errorCode=UF_ATTR_read_value(part_occ_tag,"RIVET",UF_ATTR_any,&value);PRTERR(__LINE__);

					// errorCode=UF_ATTR_read_value(child_array[i],"RIVET",UF_ATTR_any,&value);PRTERR(__LINE__);
					
					rivet_flag=0;
					if(strcmp(value.value.string,"work")==0)
								{ rivet_flag=1; sum++; }

					
					if(rivet_flag==0)
					{
						uc1601("    RIVET    ",1);
						fprintf(prterr,"\n    RIVET    ");
						fprintf(prterr,"\nchild_array[%d]=%d", i, child_array[i]);

						errorCode=0; goto term;
					}

					
				}
				else
				{
					uc1601("       RIVET",1);
					fprintf(prterr,"\nset_attr_from_color ->       RIVET");
					fprintf(prterr,"\nset_attr_from_color ->child_array[%d]  = %d", i, child_array[i]);
					fprintf(prterr,"\nset_attr_from_color ->disp_part  = %d", disp_part);
					errorCode=0; goto term;
				}
			}//for
		fprintf(prterr,"\n\nset_attr_from_color ->	sum = %d",sum);
	}	



	sel_comp=child_count;
// ( pr_code, ad_code)   ,     RIVET.
	
/*	
	
	{// 1 -    "pr_code"    

		char*	title="pr_code";
		char*	znach=atr_pr_code;

		UF_ATTR_value_t 	value;
		
		int					i;

		value.type = UF_ATTR_string;
		value.value.string = znach;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i], title, value); 
			PRTERR(__LINE__);
		}

		//fprintf(prterr,"\nset_attr_from_color ->  pr_code  %d ", i);
		if(i != rivet_count)
		{
			fprintf(prterr,"\nset_attr_from_color ->  pr_code  %d ,    %d", i, rivet_count);
			goto term;
		}

	}// 1 
	

	{// 2  -    "ad_code"    

		char*	title="ad_code";
		char*	znach=atr_ad_code;

		UF_ATTR_value_t 	value;
		
		int					i;

		value.type = UF_ATTR_string;
		value.value.string = znach;
        		
		for(i=0;i<rivet_count;i++)
		{
			errorCode=UF_ATTR_assign (rivet_array[i], title, value); 
			PRTERR(__LINE__);
		}

		//fprintf(prterr,"\nset_attr_from_color ->  ad_code  %d ", i);
		if(i != rivet_count)
		{
			fprintf(prterr,"\nset_attr_from_color ->  ad_code  %d ,    %d", i, rivet_count);
			goto term;
		}

	}// 2
*/

	


	

	
fprintf(prterr,"\nset_attr_from_color - ;  0\n");
return 0;


term:
fprintf(prterr,"\nset_attr_from_color - ;  2\n");	
return 2; 
}


